unit JoyInit;

interface


type

  FNameStr = String[79];

  TJoyVakiot = record
  Use, OnOk: Boolean;
  Cnt0, Cnt1, Cnt2, Tem1, Tem2, BVak: Integer;
  end;

const
  AbsT = 273;             { abs. lmptila 0C:ssa }

var
  JoyVakiot: array[0..3] of TJoyVakiot;
  Joy1On, Joy2On: Boolean;
  IniFileChanged: Boolean = False;

procedure UpDateIniFile;

implementation

uses inifiles, SysUtils;

var
  IniName: FNameStr;
  Li: Integer;
  KanavaStr: String[15];

procedure UpDateIniFile;
var
  Li: Integer;
begin
  IniFileChanged := False;
  with TIniFile.Create(IniName) do
  begin
    for Li := 0 to 3 do
    with JoyVakiot[Li] do
    begin
      KanavaStr := 'KANAVA' + Chr(Ord('0') + Li + 1);
      WriteBool(KanavaStr, 'Use', Use);
      WriteInteger(KanavaStr, 'Count0', Cnt0);         { 10 k piste }
      WriteInteger(KanavaStr, 'Count1', Cnt1 + Cnt0);  { 20 k piste }
      WriteInteger(KanavaStr, 'Count2', Cnt2 + Cnt0);
      WriteInteger(KanavaStr, 'Temp1', Tem1 - AbsT);
      WriteInteger(KanavaStr, 'Temp2', Tem2 - AbsT);
      WriteInteger(KanavaStr, 'BVakio', BVak);
    end;
    Joy1On := JoyVakiot[0].Use or JoyVakiot[1].Use;
    Joy2On := JoyVakiot[2].Use or JoyVakiot[3].Use;
    Free;
  end;
end;


{ initiointi }
begin
  IniName := ChangeFileExt(ParamStr(0), '.INI');
  with TIniFile.Create(IniName) do
  begin
    for Li := 0 to 3 do
    with JoyVakiot[Li] do
    begin
      KanavaStr := 'KANAVA' + Chr(Ord('0') + Li + 1);
      Use := ReadBool(KanavaStr, 'Use', False);
      Cnt0  := ReadInteger(KanavaStr, 'Count0', 200000);         { 10 k piste }
      Cnt1  := ReadInteger(KanavaStr, 'Count1', 400000) - Cnt0;  { 20 k piste }
      Cnt2  := ReadInteger(KanavaStr, 'Count2', 0) - Cnt0;
      Tem1  := ReadInteger(KanavaStr, 'Temp1', 25) + AbsT;
      Tem2  := ReadInteger(KanavaStr, 'Temp2', 0) + AbsT;
      BVak  := ReadInteger(KanavaStr, 'BVakio', 3977);
      if Cnt2 > 0
      then BVak := Round(Ln(Cnt1 / Cnt2) / (1 / Tem1 - 1 / Tem2));
    end;
    Joy1On := JoyVakiot[0].Use or JoyVakiot[1].Use;
    Joy2On := JoyVakiot[2].Use or JoyVakiot[3].Use;
    Free;
  end;
end.
